package edu.ucr.util;

/*
 * Copyright 2020 Renjie Wu
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

import com.timeseries.TimeSeries;

import java.io.BufferedReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;

public class TsvReader {
    public static void readTsv(String path, ArrayList<double[]> data,
                               ArrayList<TimeSeries> dataTS, ArrayList<Integer> label) throws IOException {
        try (var tsvReader = new BufferedReader(new java.io.FileReader(path))) {
            String line;

            while (null != (line = tsvReader.readLine())) {
                var columns = line.split("\t");

                // not empty line
                if (columns.length > 1) {
                    label.add(Integer.parseInt(columns[0]));

                    var points = Arrays.stream(columns).skip(1).mapToDouble(Double::parseDouble).toArray();
                    data.add(points);
                    dataTS.add(new TimeSeries(points));
                }
            }
        }
    }
}
